require("regex_lua");
--ownerdrawpoints_wrapper

function wrap_ownerdrawnpoints(orig)
  local RealGet = orig.get
  function orig.get(self, index)
    local result = {}
    local tmpresult = {RealGet(self, index)}
    local i,v
    for i,v in ipairs(tmpresult) do
      result[i - 1] = v
    end
    return result
  end
  return orig
end

function ownerdraw_points.create(self)
  return wrap_ownerdrawnpoints(ownerdraw_points.new())
end

-- expat_lua
ExpatLua = {}
ExpatLua.__index = ExpatLua

function ExpatLua.parseDOM(self, xml)
  if (ExpatLua.__index ~= self) then
    return expat_lua.parseDOM(self)
  end
  return expat_lua.parseDOM(xml)
end

function ExpatLua.parseSAX (self, xml, handler)
  if (ExpatLua.__index ~= self) then
    return expat_lua.parseSAX (self, xml)
  end
  return expat_lua.parseSAX (xml, handler)
end
function ExpatLua.utf8_to_ansi (self, utf8)
  if (ExpatLua.__index ~= self) then
    return expat_lua.utf8_to_ansi (self)
  end
  return expat_lua.utf8_to_ansi (utf8)
end

ownerdraw_points.RealCreate = ownerdraw_points.create
function ownerdraw_points.create()
  t = ownerdraw_points.RealCreate()
  t.RealGet = t.get

  t.get = function (self, index)
      local tmpresult = {self.RealGet(self, index)}
      for i,v in ipairs(tmpresult) do
        result[i - 1] = v
      end
      return result
  end
  return t
end


-- HttpLoader
HttpLoader = {}
HttpLoader.__index = HttpLoader

function HttpLoader.cancel(self)
  if (HttpLoader.__index ~= self) then
    return http_loader.cancel()
  end
  return http_loader.cancel()
end

function HttpLoader.load(self, host, port, object, async)
  if (HttpLoader.__index ~= self) then
    return http_loader.load(self, host, port, object)
  end
  return http_loader.load(host, port, object, async)
end

function HttpLoader.loading(self)
  if (HttpLoader.__index ~= self) then
    return http_loader.loading()
  end
  return http_loader.loading()
end

function HttpLoader.response(self)
  if (HttpLoader.__index ~= self) then
    return http_loader.response()
  end
  return http_loader.response()
end

function HttpLoader.successful(self)
  if (HttpLoader.__index ~= self) then
    return http_loader.successful()
  end
  return http_loader.successful()
end

-- Math functions
Math = {}
Math.__index = Math

function Math.abs(self, x)
  if (Math.__index ~= self) then
    return math.abs(self)
  end
  return math.abs(x)
end

function Math.acos(self, x)
  if (Math.__index ~= self) then
    return math.acos(self)
  end
  return math.acos(x)
end

function Math.asin(self, x)
  if (Math.__index ~= self) then
    return math.asin(self)
  end
  return math.asin(x)
end

function Math.atan(self, x)
  if (Math.__index ~= self) then
    return math.atan(self)
  end
  return math.atan(x)
end

function Math.atan2(self, x, y)
  if (Math.__index ~= self) then
    return math.atan2(self, x)
  end
  return math.atan2(x, y)
end

function Math.ceil(self, x)
  if (Math.__index ~= self) then
    return math.ceil(self)
  end
  return math.ceil(x)
end

function Math.cos(self, x)
  if (Math.__index ~= self) then
    return math.cos(self)
  end
  return math.cos(x)
end

function Math.cosh(self, x)
  if (Math.__index ~= self) then
    return math.cosh(self)
  end
  return math.cosh(x)
end

function Math.deg(self, x)
  if (Math.__index ~= self) then
    return math.deg(self)
  end
  return math.deg(x)
end

function Math.exp(self, x)
  if (Math.__index ~= self) then
    return math.exp(self)
  end
  return math.exp(x)
end

function Math.floor(self, x)
  if (Math.__index ~= self) then
    return math.floor(self)
  end
  return math.floor(x)
end

function Math.fmod(self, x)
  if (Math.__index ~= self) then
    return math.fmod(self)
  end
  return math.fmod(x)
end

function Math.frexp(self, x)
  if (Math.__index ~= self) then
    return math.frexp(self)
  end
  return math.frexp(x)
end

function Math.ldexp(self, m, e)
  if (Math.__index ~= self) then
    return math.ldexp(self, m)
  end
  return math.ldexp(m, e)
end

function Math.log(self, x)
  if (Math.__index ~= self) then
    return math.log(self)
  end
  return math.log(x)
end

function Math.log10(self, x)
  if (Math.__index ~= self) then
    return math.log10(self)
  end
  return math.log10(x)
end

function Math.max(x, ...)
  local unpack = table.unpack or unpack
  if (Math.__index ~= x) then
    return math.max(x, unpack({...}))
  end
  return math.max(unpack({...}))
end

function Math.min(x, ...)
  local unpack = table.unpack or unpack
  if (Math.__index ~= x) then
    return math.min(x, unpack({...}))
  end
  return math.min(unpack({...}))
end

function Math.modf(self, x)
  if (Math.__index ~= self) then
    return math.modf(self)
  end
  return math.modf(x)
end

function Math.pow(self, x, y)
  if (Math.__index ~= self) then
    return math.pow(self, x)
  end
  return math.pow(x, y)
end

function Math.rad(self, x)
  if (Math.__index ~= self) then
    return math.rad(self)
  end
  return math.rad(x)
end

function Math.random(self, m, n)
  if (Math.__index ~= self) then
    return math.random(self, m)
  end
  return math.random(m, n)
end

function Math.randomseed(self, x)
  if (Math.__index ~= self) then
    return math.randomseed(self)
  end
  return math.randomseed(x)
end

function Math.sin(self, x)
  if (Math.__index ~= self) then
    return math.sin(self)
  end
  return math.sin(x)
end

function Math.sinh(self, x)
  if (Math.__index ~= self) then
    return math.sinh(self)
  end
  return math.sinh(x)
end

function Math.sqrt(self, x)
  if (Math.__index ~= self) then
    return math.sqrt(self)
  end
  return math.sqrt(x)
end

function Math.tan(self, x)
  if (Math.__index ~= self) then
    return math.tan(self)
  end
  return math.tan(x)
end

function Math.round(self, num, idp)
  if (Math.__index ~= self) then
    local mult = 10^(num or 0)
    return math.floor(self * mult + 0.5) / mult
  end
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function Math.tanh(self, x)
  if (Math.__index ~= self) then
    return math.tanh(self)
  end
  return math.tanh(x)
end

function Math.avg(self, stream, range, to)
  if (Math.__index ~= self) then
    return mathex.avg(self, stream, range);
  end
  return mathex.avg(stream, range, to);
end

function Math.betaDist(self, x, a, b)
  if (Math.__index ~= self) then
    return mathex.betaDist(self, x, a);
  end
  return mathex.betaDist(x, a, b);
end

function Math.betaDistInv(self, p, a, b)
  if (Math.__index ~= self) then
    return mathex.betaDistInv(self, p, a);
  end
  return mathex.betaDistInv(p, a, b);
end

function Math.binomDist(self, trials, succeeds, p)
  if (Math.__index ~= self) then
    return mathex.binomDist(self, trials, succeeds);
  end
  return mathex.binomDist(trials, succeeds, p);
end

function Math.cfft(self, array)
  if (Math.__index ~= self) then
    return mathex.cfft(self);
  end
  return mathex.cfft(array);
end

function Math.chiDist(self, x, n)
  if (Math.__index ~= self) then
    return mathex.chiDist(self, x);
  end
  return mathex.chiDist(x, n);
end

function Math.correl(self, first_stream, second_stream, first_from, first_to, second_from, second_to)
  if (Math.__index ~= self) then
    return mathex.correl(self, first_stream, second_stream, first_from, first_to, second_from);
  end
  return mathex.correl(first_stream, second_stream, first_from, first_to, second_from, second_to);
end

function Math.covar(self, first_stream, second_stream, first_from, first_to, second_from, second_to)
  if (Math.__index ~= self) then
    return mathex.covar(self, first_stream, second_stream, first_from, first_to, second_from);
  end
  return mathex.covar(first_stream, second_stream, first_from, first_to, second_from, second_to);
end

function Math.devsq(self, stream, range, to)
  if (Math.__index ~= self) then
    return mathex.devsq(self, stream, range);
  end
  return mathex.devsq(stream, range, to);
end

function Math.expDist(self, x, lambda)
  if (Math.__index ~= self) then
    return mathex.expDist(self, x);
  end
  return mathex.expDist(x, lambda);
end

function Math.fDist(self, x, n, m)
  if (Math.__index ~= self) then
    return mathex.fDist(self, x, n);
  end
  return mathex.fDist(x, n, m);
end

function Math.fDistInv(self, p, n, m)
  if (Math.__index ~= self) then
    return mathex.fDistInv(self, p, n);
  end
  return mathex.fDistInv(p, n, m);
end

function Math.fft(self, array)
  if (Math.__index ~= self) then
    return mathex.fft(self);
  end
  return mathex.fft(array);
end

function Math.gammaDist(self, x, a, scale)
  if (Math.__index ~= self) then
    return mathex.gammaDist(self, x, a);
  end
  return mathex.gammaDist(x, a, scale);
end

function Math.gammaDistInv(self, p, a, scale)
  if (Math.__index ~= self) then
    return mathex.gammaDistInv(self, p, a);
  end
  return mathex.gammaDistInv(p, a, scale);
end

function Math.gammaln(self, x)
  if (Math.__index ~= self) then
    return mathex.gammaln(self);
  end
  return mathex.gammaln(x);
end

function Math.geomean(self, stream, range, to)
  if (Math.__index ~= self) then
    return mathex.geomean(self, stream, range);
  end
  return mathex.geomean(stream, range, to);
end

function Math.icfft(self, array)
  if (Math.__index ~= self) then
    return mathex.icfft(self);
  end
  return mathex.icfft(array);
end

function Math.ifft(self, array)
  if (Math.__index ~= self) then
    return mathex.ifft(self);
  end
  return mathex.ifft(array);
end

function Math.kurt(self, stream, range, to)
  if (Math.__index ~= self) then
    return mathex.kurt(self, stream, range);
  end
  return mathex.kurt(stream, range, to);
end

function Math.lreg(self, stream, range, to)
  if (Math.__index ~= self) then
    return mathex.lreg(self, stream, range);
  end
  return mathex.lreg(stream, range, to);
end

function Math.lregSlope(self, stream, range, to)
  if (Math.__index ~= self) then
    return mathex.lregSlope(self, stream, range);
  end
  return mathex.lregSlope(stream, range, to);
end

function Math.lwma(self, stream, range, to)
  if (Math.__index ~= self) then
    return mathex.lwma(self, stream, range);
  end
  return mathex.lwma(stream, range, to);
end

function Math.makeArray(self, size)
  if (Math.__index ~= self) then
    return mathex.makeArray(self);
  end
  return mathex.makeArray(size);
end

function Math.smax(self, stream, range, to)
  local result = {}
  local tmpresult = {}
  if (Math.__index ~= self) then
    tmpresult = {mathex.max(self, stream, range)};
  else
    tmpresult = {mathex.max(stream, range, to)};
  end
  local i,v
  for i,v in ipairs(tmpresult) do
    result[i - 1] = v
  end
  return result
end

function Math.smax2(self, stream, range, to)
  local result = {}
  local tmpresult = {}
  if (Math.__index ~= self) then
    tmpresult = {mathex.max2(self, stream, range)};
  else
    tmpresult = {mathex.max2(stream, range, to)};
  end
  local i,v
  for i,v in ipairs(tmpresult) do
    result[i - 1] = v
  end
  return result
end

function Math.meandev(self, stream, range, to)
  if (Math.__index ~= self) then
    return mathex.meandev(self, stream, range);
  end
  return mathex.meandev(stream, range, to);
end

function Math.median_s(self, stream, range, to)
  if (Math.__index ~= self) then
    return mathex.median_s(self, stream, range);
  end
  return mathex.median_s(stream, range, to);
end

function Math.median_w(self, stream, range, to)
  if (Math.__index ~= self) then
    return mathex.median_w(self, stream, range);
  end
  return mathex.median_w(stream, range, to);
end

function Math.smin(self, stream, range, to)
  local result = {}
  local tmpresult = {}
  if (Math.__index ~= self) then
    tmpresult = {mathex.min(self, stream, range)};
  else
    tmpresult = {mathex.min(stream, range, to)};
  end
  local i,v
  for i,v in ipairs(tmpresult) do
    result[i - 1] = v
  end
  return result
end

function Math.smin2(self, stream, range, to)
  local result = {}
  local tmpresult = {}
  if (Math.__index ~= self) then
    tmpresult = {mathex.min2(self, stream, range)};
  else
    tmpresult = {mathex.min2(stream, range, to)};
  end
  local i,v
  for i,v in ipairs(tmpresult) do
    result[i - 1] = v
  end
  return result
end

function Math.minmax(self, stream, range, to)
  local result = {}
  local tmpresult = {}
  if (Math.__index ~= self) then
    tmpresult = {mathex.minmax(self, stream, range)};
  else
    tmpresult = {mathex.minmax(stream, range, to)};
  end
  local i,v
  for i,v in ipairs(tmpresult) do
    result[i - 1] = v
  end
  return result
end

function Math.normalDist(self, x, mean, variation)
  if (Math.__index ~= self) then
    return mathex.normalDist(self, x, mean);
  end
  return mathex.normalDist(x, mean, variation);
end

function Math.poissonDist(self, x, mean)
  if (Math.__index ~= self) then
    return mathex.poissonDist(self, x);
  end
  return mathex.poissonDist(x, mean);
end

function Math.regChannel(self, stream, from, to)
  local result = {}
  local tmpresult = {}
  if (Math.__index ~= self) then
    tmpresult = {mathex.regChannel(self, stream, from)};
  else
    tmpresult = {mathex.regChannel(stream, from, to)};
  end
  local i,v
  for i,v in ipairs(tmpresult) do
    result[i - 1] = v
  end
  return result
end

function Math.skew(self, stream, range, to)
  if (Math.__index ~= self) then
    return mathex.skew(self, stream, range);
  end
  return mathex.skew(stream, range, to);
end

function Math.stdev(self, stream, range, to)
  if (Math.__index ~= self) then
    return mathex.stdev(self, stream, range);
  end
  return mathex.stdev(stream, range, to);
end

function Math.studentDist(self, x, n)
  if (Math.__index ~= self) then
    return mathex.studentDist(self, x);
  end
  return mathex.studentDist(x, n);
end

function Math.sum(self, stream, range, to)
  if (Math.__index ~= self) then
    return mathex.sum(self, stream, range);
  end
  return mathex.sum(stream, range, to);
end

function Math.weibullDist(self, x, a, variation)
  if (Math.__index ~= self) then
    return mathex.weibullDist(self, x, a);
  end
  return mathex.weibullDist(x, a, variation);
end

MathEx = {}
MathEx.__index = MathEx

function MathEx.avg(self, stream, range, to)
  if (MathEx.__index ~= self) then
    return mathex.avg(self, stream, range);
  end
  return mathex.avg(stream, range, to);
end

function MathEx.betaDist(self, x, a, b)
  if (MathEx.__index ~= self) then
    return mathex.betaDist(self, x, a);
  end
  return mathex.betaDist(x, a, b);
end

function MathEx.betaDistInv(self, p, a, b)
  if (MathEx.__index ~= self) then
    return mathex.betaDistInv(self, p, a);
  end
  return mathex.betaDistInv(p, a, b);
end

function MathEx.binomDist(self, trials, succeeds, p)
  if (MathEx.__index ~= self) then
    return mathex.binomDist(self, trials, succeeds);
  end
  return mathex.binomDist(trials, succeeds, p);
end

function MathEx.cfft(self, array)
  if (MathEx.__index ~= self) then
    return mathex.cfft(self);
  end
  return mathex.cfft(array);
end

function MathEx.chiDist(self, x, n)
  if (MathEx.__index ~= self) then
    return mathex.chiDist(self, x);
  end
  return mathex.chiDist(x, n);
end

function MathEx.correl(self, first_stream, second_stream, first_from, first_to, second_from, second_to)
  if (MathEx.__index ~= self) then
    return mathex.correl(self, first_stream, second_stream, first_from, first_to, second_from);
  end
  return mathex.correl(first_stream, second_stream, first_from, first_to, second_from, second_to);
end

function MathEx.covar(self, first_stream, second_stream, first_from, first_to, second_from, second_to)
  if (MathEx.__index ~= self) then
    return mathex.covar(self, first_stream, second_stream, first_from, first_to, second_from);
  end
  return mathex.covar(first_stream, second_stream, first_from, first_to, second_from, second_to);
end

function MathEx.devsq(self, stream, range, to)
  if (MathEx.__index ~= self) then
    return mathex.devsq(self, stream, range);
  end
  return mathex.devsq(stream, range, to);
end

function MathEx.expDist(self, x, lambda)
  if (MathEx.__index ~= self) then
    return mathex.expDist(self, x);
  end
  return mathex.expDist(x, lambda);
end

function MathEx.fDist(self, x, n, m)
  if (MathEx.__index ~= self) then
    return mathex.fDist(self, x, n);
  end
  return mathex.fDist(x, n, m);
end

function MathEx.fDistInv(self, p, n, m)
  if (MathEx.__index ~= self) then
    return mathex.fDistInv(self, p, n);
  end
  return mathex.fDistInv(p, n, m);
end

function MathEx.fft(self, array)
  if (MathEx.__index ~= self) then
    return mathex.fft(self);
  end
  return mathex.fft(array);
end

function MathEx.gammaDist(self, x, a, scale)
  if (MathEx.__index ~= self) then
    return mathex.gammaDist(self, x, a);
  end
  return mathex.gammaDist(x, a, scale);
end

function MathEx.gammaDistInv(self, p, a, scale)
  if (MathEx.__index ~= self) then
    return mathex.gammaDistInv(self, p, a);
  end
  return mathex.gammaDistInv(p, a, scale);
end

function MathEx.gammaln(self, x)
  if (MathEx.__index ~= self) then
    return mathex.gammaln(self);
  end
  return mathex.gammaln(x);
end

function MathEx.geomean(self, stream, range, to)
  if (MathEx.__index ~= self) then
    return mathex.geomean(self, stream, range);
  end
  return mathex.geomean(stream, range, to);
end

function MathEx.icfft(self, array)
  if (MathEx.__index ~= self) then
    return mathex.icfft(self);
  end
  return mathex.icfft(array);
end

function MathEx.ifft(self, array)
  if (MathEx.__index ~= self) then
    return mathex.ifft(self);
  end
  return mathex.ifft(array);
end

function MathEx.kurt(self, stream, range, to)
  if (MathEx.__index ~= self) then
    return mathex.kurt(self, stream, range);
  end
  return mathex.kurt(stream, range, to);
end

function MathEx.lreg(self, stream, range, to)
  if (MathEx.__index ~= self) then
    return mathex.lreg(self, stream, range);
  end
  return mathex.lreg(stream, range, to);
end

function MathEx.lregSlope(self, stream, range, to)
  if (MathEx.__index ~= self) then
    return mathex.lregSlope(self, stream, range);
  end
  return mathex.lregSlope(stream, range, to);
end

function MathEx.lwma(self, stream, range, to)
  if (MathEx.__index ~= self) then
    return mathex.lwma(self, stream, range);
  end
  return mathex.lwma(stream, range, to);
end

function MathEx.makeArray(self, size)
  if (MathEx.__index ~= self) then
    return mathex.makeArray(self);
  end
  return mathex.makeArray(size);
end

function MathEx.max(self, stream, range, to)
  local result = {}
  local tmpresult = {}
  if (MathEx.__index ~= self) then
    tmpresult = {mathex.max(self, stream, range)};
  else
    tmpresult = {mathex.max(stream, range, to)};
  end
  local i,v
  for i,v in ipairs(tmpresult) do
    result[i - 1] = v
  end
  return result
end

function MathEx.max2(self, stream, range, to)
  local result = {}
  local tmpresult = {}
  if (MathEx.__index ~= self) then
    tmpresult = {mathex.max2(self, stream, range)};
  else
    tmpresult = {mathex.max2(stream, range, to)};
  end
  local i,v
  for i,v in ipairs(tmpresult) do
    result[i - 1] = v
  end
  return result
end

function MathEx.meandev(self, stream, range, to)
  if (MathEx.__index ~= self) then
    return mathex.meandev(self, stream, range);
  end
  return mathex.meandev(stream, range, to);
end

function MathEx.median_s(self, stream, range, to)
  if (MathEx.__index ~= self) then
    return mathex.median_s(self, stream, range);
  end
  return mathex.median_s(stream, range, to);
end

function MathEx.median_w(self, stream, range, to)
  if (MathEx.__index ~= self) then
    return mathex.median_w(self, stream, range);
  end
  return mathex.median_w(stream, range, to);
end

function MathEx.min(self, stream, range, to)
  local result = {}
  local tmpresult = {}
  if (MathEx.__index ~= self) then
    tmpresult = {mathex.min(self, stream, range)};
  else
    tmpresult = {mathex.min(stream, range, to)};
  end
  local i,v
  for i,v in ipairs(tmpresult) do
    result[i - 1] = v
  end
  return result
end

function MathEx.min2(self, stream, range, to)
  local result = {}
  local tmpresult = {}
  if (MathEx.__index ~= self) then
    tmpresult = {mathex.min2(self, stream, range)};
  else
    tmpresult = {mathex.min2(stream, range, to)};
  end
  local i,v
  for i,v in ipairs(tmpresult) do
    result[i - 1] = v
  end
  return result
end

function MathEx.minmax(self, stream, range, to)
  local result = {}
  local tmpresult = {}
  if (MathEx.__index ~= self) then
    tmpresult = {mathex.minmax(self, stream, range)};
  else
    tmpresult = {mathex.minmax(stream, range, to)};
  end
  local i,v
  for i,v in ipairs(tmpresult) do
    result[i - 1] = v
  end
  return result
end

function MathEx.normalDist(self, x, mean, variation)
  if (MathEx.__index ~= self) then
    return mathex.normalDist(self, x, mean);
  end
  return mathex.normalDist(x, mean, variation);
end

function MathEx.poissonDist(self, x, mean)
  if (MathEx.__index ~= self) then
    return mathex.poissonDist(self, x);
  end
  return mathex.poissonDist(x, mean);
end

function MathEx.regChannel(self, stream, from, to)
  local result = {}
  local tmpresult = {}
  if (MathEx.__index ~= self) then
    tmpresult = {mathex.regChannel(self, stream, from)};
  else
    tmpresult = {mathex.regChannel(stream, from, to)};
  end
  local i,v
  for i,v in ipairs(tmpresult) do
    result[i - 1] = v
  end
  return result
end

function MathEx.skew(self, stream, range, to)
  if (MathEx.__index ~= self) then
    return mathex.skew(self, stream, range);
  end
  return mathex.skew(stream, range, to);
end

function MathEx.stdev(self, stream, range, to)
  if (MathEx.__index ~= self) then
    return mathex.stdev(self, stream, range);
  end
  return mathex.stdev(stream, range, to);
end

function MathEx.studentDist(self, x, n)
  if (MathEx.__index ~= self) then
    return mathex.studentDist(self, x);
  end
  return mathex.studentDist(x, n);
end

function MathEx.sum(self, stream, range, to)
  if (MathEx.__index ~= self) then
    return mathex.sum(self, stream, range);
  end
  return mathex.sum(stream, range, to);
end

function MathEx.weibullDist(self, x, a, variation)
  if (MathEx.__index ~= self) then
    return mathex.weibullDist(self, x, a);
  end
  return mathex.weibullDist(x, a, variation);
end

--String functions
String = {}
String.__index = String

function String.format(f, ... )
    local unpack = table.unpack or unpack
    if (String.__index ~= f) then
     return string.format(f, unpack({...}))
    end
    return string.format(unpack({...}))
end


function String.byte(self, s, i, j)
  if (String.__index ~= self) then
    return string.byte(self, s, i)
  end
  return string.byte(s, i, j);
end

function String.char(f, ...)
  local unpack = table.unpack or unpack
  if (String.__index ~= self) then
    return string.char(f, unpack({...}))
  end
  return string.char(unpack({...}));
end

function String.dump(self, f)
  if (String.__index ~= self) then
    return string.dump(self)
  end
  return string.dump(f);
end

function String.find(self, s, pattern, init, plain)
  if (String.__index ~= self) then
    return string.find(self, s, pattern, init)
  end
  return string.find(s, pattern, init, plain);
end

function String.gmatch(self, s, pattern)
  if (String.__index ~= self) then
    return string.gmatch(self, s)
  end
  return string.gmatch(s, pattern);
end

function String.gsub(self, s, pattern, repl, n)
  if (String.__index ~= self) then
    return string.gsub(self, s, pattern, repl)
  end
  return string.gsub(s, pattern, repl, n);
end

function String.len(self, s)
  if (String.__index ~= self) then
    return string.len(self)
  end
  return string.len(s);
end

function String.lower(self, s)
  if (String.__index ~= self) then
    return string.lower(self)
  end
  return string.lower(s);
end

function String.match(self, s, pattern, init)
  if (String.__index ~= self) then
    return string.match(self, s, pattern);
  end
  return string.match(s, pattern, init);
end

function String.rep(self, s, n)
  if (String.__index ~= self) then
    return string.rep(self, s)
  end
  return string.rep(s, n);
end

function String.reverse(self, s)
  if (String.__index ~= self) then
    return string.reverse(self)
  end
  return string.reverse(s);
end

function String.split(self, sep)
 local fields = {}
 local sep
 if (String.__index ~= self) then
    sep = self or ";"
 else
    sep = sep or ";"
 end
 local pattern = String.format("([^%s]+)", sep)
 self.gsub(pattern, function(c) fields[#fields + 1] = c end)
 return fields
end

function String.sub(self, s, i, j)
  if (String.__index ~= self) then
    return string.sub(self, s, i)
  end
  return string.sub(s, i, j);
end

function String.upper(self, s)
  if (String.__index ~= self) then
    return string.upper(self)
  end
  return string.upper(s);
end

StorageDB = {}
StorageDB.__index = StorageDB

function StorageDB.get_db(self, name)
  if (StorageDB.__index ~= self) then
    return storagedb.get_db(self)
  end
  return storagedb.get_db(name);
end

DB = {}
DB.__index = DB

function DB.get(self, name, default)
  if (DB.__index ~=self) then
    return db.get(self, name)
  end
  return db.get(name, default)
end

function DB.put(self, name, value)
  if (DB.__index ~=self) then
    return db.put(self, name)
  end
  return db.put(name, value)
end

Table = {}
Table.__index = Table

function Table.concat(self, table, sep, i, j)
  if (Table.__index ~= self) then
    return table.concat(self, table, sep, i)
  end
  return table.concat(table, sep, i, j)
end

function Table.foreach(self, table, f)
  if (Table.__index ~= self) then
    return table.foreach(self, table)
  end
  return table.foreach(table, f)
end

function Table.foreachi(self, table, f)
  if (Table.__index ~= self) then
    return table.foreachi(self, table)
  end
  return table.foreachi(table, f)
end

function Table.sort(self, table, comp)
  if (Table.__index ~= self) then
    return table.sort(self, table)
  end
  return table.sort(table, comp)
end

function Table.insert(self, table, pos, value)
  if (Table.__index ~= self) then
    return table.insert(self, table, pos)
  end
  return table.insert(table, pos, value)
end

function Table.remove(self, table, pos)
  if (Table.__index ~= self) then
    return table.remove(self, table)
  end
  return table.remove(table, pos)
end

function Table.maxn(self, table)
  if (Table.__index ~= self) then
    return table.maxn(self)
  end
  return table.maxn(table)
end

function Table.getn(self, table)
  if (Table.__index ~= self) then
    return #self
  end
  return #table
end

function length(table)
  if table == nil then
    return 0
  end

  return table[0] ~= nil and #table + 1 or #table
end

-- Math2D functions
Math2D = {}
Math2D.__index = Math2D

function Math2D.cartesianToPolar(self, x, y)
    local result = {}
    local tmpresult = {}
    if (Math2D.__index ~= self) then
        tmpresult = {math2d.cartesianToPolar(self, x)}
    else
        tmpresult = {math2d.cartesianToPolar(x, y)}
    end
    local i,v
    for i,v in ipairs(tmpresult) do
        result[i - 1] = v
    end
    return result
end

function Math2D.isPointInRect(self, x, y, x1, y1, x2, y2)
    if (Math2D.__index ~= self) then
        return math2d.isPointInRect(self, x, y, x1, y1)
    end
    return math2d.isPointInRect(x, y, x1, y1, x2, y2)
end

function Math2D.isPointOnLine(self, x, y, x1, y1, x2, y2)
    if (Math2D.__index ~= self) then
        return math2d.isPointOnLine(self, x, y, x1, y1)
    end
    return math2d.isPointOnLine(x, y, x1, y1, x2, y2)
end

function Math2D.isPointOnSegment(self, x, y, x1, y1, x2, y2)
    if (Math2D.__index ~= self) then
        return math2d.isPointOnSegment(self, x, y, x1, y1, x2)
    end
    return math2d.isPointOnSegment(x, y, x1, y1, x2, y2)
end

function Math2D.lineEllipseIntersection(self, ex1, ey1, ex2, ey2, lx1, ly1, lx2, ly2)
    local result = {}
    local tmpresult = {}
    if (Math2D.__index ~= self) then
        tmpresult = {math2d.lineEllipseIntersection(self, ex1, ey1, ex2, ey2, lx1, ly1, lx2)}
    else
        tmpresult = {math2d.lineEllipseIntersection(ex1, ey1, ex2, ey2, lx1, ly1, lx2, ly2)}
    end
    local i,v
    for i,v in ipairs(tmpresult) do
        result[i - 1] = v
    end
    return result
end

function Math2D.lineEquation(self, x1, y1, x2, y2)
    local result = {}
    local tmpresult = {}
    if (Math2D.__index ~= self) then
        tmpresult = {math2d.lineEquation(self, x1, y1, x2)}
    else
        tmpresult = {math2d.lineEquation(x1, y1, x2, y2)}
    end
    local i,v
    for i,v in ipairs(tmpresult) do
        result[i - 1] = v
    end
    return result
end

function Math2D.lineIntersection(self, l1x1, l1y1, l1x2, l1y2, l2x1, l2y1, l2x2, l2y2)
    local result = {}
    local tmpresult = {}
    if (Math2D.__index ~= self) then
        tmpresult = {math2d.lineIntersection(self, l1x1, l1y1, l1x2, l1y2, l2x1, l2y1, l2x2)}
    else
        tmpresult = {math2d.lineIntersection(l1x1, l1y1, l1x2, l1y2, l2x1, l2y1, l2x2, l2y2)}
    end
    local i,v
    for i,v in ipairs(tmpresult) do
        result[i - 1] = v
    end
    return result
end

function Math2D.lineRectangleIntersection(self, rx1, ry1, rx2, ry2, lx1, ly1, lx2, ly2)
    local result = {}
    local tmpresult = {}
    if (Math2D.__index ~= self) then
        tmpresult = {math2d.lineRectangleIntersection(self, rx1, ry1, rx2, ry2, lx1, ly1, lx2)}
    else
        tmpresult = {math2d.lineRectangleIntersection(rx1, ry1, rx2, ry2, lx1, ly1, lx2, ly2)}
    end
    local i,v
    for i,v in ipairs(tmpresult) do
        result[i - 1] = v
    end
    return result
end

function Math2D.polarToCartesian(self, r, p)
    local result = {}
    local tmpresult = {}
    if (Math2D.__index ~= self) then
        tmpresult = {math2d.polarToCartesian(self, r)}
    else
        tmpresult = {math2d.polarToCartesian(r, p)}
    end
    local i,v
    for i,v in ipairs(tmpresult) do
        result[i - 1] = v
    end
    return result
end

function Math2D.polygonToBezierShape(self, points, smooth)
    if (Math2D.__index ~= self) then
        return wrap_ownerdrawnpoints(math2d.polygonToBezierShape(self, points))
    end
    return wrap_ownerdrawnpoints(math2d.polygonToBezierShape(points, smooth))
end

function Math2D.polylineToBezierLine(self, points, smooth)
    if (Math2D.__index ~= self) then
        return wrap_ownerdrawnpoints(math2d.polylineToBezierLine(self, points))
    end
    return wrap_ownerdrawnpoints(math2d.polylineToBezierLine(points, smooth))
end

function Math2D.projectPointOnLine(self, x, y, x1, y1, x2, y2)
    local result = {}
    local tmpresult = {}
    if (Math2D.__index ~= self) then
        tmpresult = {math2d.projectPointOnLine(self, x, y, x1, y1, x2)}
    else
        tmpresult = {math2d.projectPointOnLine(x, y, x1, y1, x2, y2)}
    end
    local i,v
    for i,v in ipairs(tmpresult) do
        result[i - 1] = v
    end
    return result
end

function Math2D.scaleShiftTransform(self, points, base_points, base_points_projected, xfilter, yfilter)
    if (Math2D.__index ~= self) then
        return math2d.scaleShiftTransform(self, points, base_points, base_points_projected, xfilter)
    end
    return math2d.scaleShiftTransform(points, base_points, base_points_projected, xfilter, yfilter)
end

function Math2D.segmentIntersection(self, l1x1, l1y1, l1x2, l1y2, l2x1, l2y1, l2x2, l2y2)
    local result = {}
    local tmpresult = {}
    if (Math2D.__index ~= self) then
        tmpresult = {math2d.segmentIntersection(self, l1x1, l1y1, l1x2, l1y2, l2x1, l2y1, l2x2)}
    else
        tmpresult = {math2d.segmentIntersection(l1x1, l1y1, l1x2, l1y2, l2x1, l2y1, l2x2, l2y2)}
    end
    local i,v
    for i,v in ipairs(tmpresult) do
        result[i - 1] = v
    end
    return result
end

function Math2D.segmentRectangleIntersection(self, rx1, ry1, rx2, ry2, lx1, ly1, lx2, ly2)
    local result = {}
    local tmpresult = {}
    if (Math2D.__index ~= self) then
        tmpresult = {math2d.segmentRectangleIntersection(self, rx1, ry1, rx2, ry2, lx1, ly1, lx2)}
    else
        tmpresult = {math2d.segmentRectangleIntersection(rx1, ry1, rx2, ry2, lx1, ly1, lx2, ly2)}
    end
    local i,v
    for i,v in ipairs(tmpresult) do
        result[i - 1] = v
    end
    return result
end

-- expat_lua
Win32 = {}
Win32.__index = Win32

Win32.NONE = win32.NONE
Win32.SHORT = win32.SHORT
Win32.LONG = win32.LONG
Win32.ATTR_ARCHIVE = win32.ATTR_ARCHIVE
Win32.ATTR_DIRECTORY = win32.ATTR_DIRECTORY
Win32.ATTR_HIDDEN = win32.ATTR_HIDDEN
Win32.ATTR_READONLY = win32.ATTR_READONLY
Win32.ATTR_SYSTEM = win32.ATTR_SYSTEM
Win32.ATTR_TEMPORARY = win32.ATTR_TEMPORARY

function Win32.convertTimeZoneToUTC(self, tz, date)
    if (Win32.__index ~= self) then
        return win32.convertTimeZoneToUTC(self, tz)
    end
    return win32.convertTimeZoneToUTC(tz, date)
end

function Win32.convertUTCToTimeZone(self, tz, date)
    if (Win32.__index ~= self) then
        return win32.convertUTCToTimeZone(self, tz)
    end
    return win32.convertUTCToTimeZone(tz, date)
end

function Win32.copyFile(self, existingFileName, newFileName, overwrite)
    if (Win32.__index ~= self) then
        return win32.copyFile(self, existingFileName, newFileName)
    end
    return win32.copyFile(existingFileName, newFileName, overwrite)
end

function Win32.createFolder(self, folderName)
    if (Win32.__index ~= self) then
        return win32.createFolder(self)
    end
    return win32.createFolder(folderName)
end

function Win32.currentTimeLocal(self)
    return win32.currentTimeLocal()
end

function Win32.currentTimeUTC(self)
    return win32.currentTimeUTC()
end

function Win32.deleteFile(self, fileName)
    if (Win32.__index ~= self) then
        return win32.deleteFile(self)
    end
    return win32.deleteFile(fileName)
end

function Win32.deleteFolder(self, folderName)
    if (Win32.__index ~= self) then
        return win32.deleteFolder(self)
    end
    return win32.deleteFolder(folderName)
end

function Win32.enumRegistry(self, keyName)
    local result = {}
    local tmpresult = {}
    if (Win32.__index ~= self) then
        tmpresult = {win32.enumRegistry(self)};
    else
        tmpresult = {win32.enumRegistry(keyName)};
    end
    local i,v
    for i,v in ipairs(tmpresult) do
        result[i - 1] = v
    end
    return result
end

function Win32.fileAttributes(self, fileName)
    if (Win32.__index ~= self) then
        return win32.fileAttributes(self)
    end
    return win32.fileAttributes(fileName)
end

function Win32.files(self, mask)
    if (Win32.__index ~= self) then
        return win32.files(self)
    end
    return win32.files(mask)
end

function Win32.formatDate(self, date, dateFormat, timeFormat)
    if (Win32.__index ~= self) then
        return win32.formatDate(self, date, dateFormat)
    end
    return win32.formatDate(date, dateFormat, timeFormat)
end

function Win32.formatNumber(self, value, groupping, precision)
    if (Win32.__index ~= self) then
        return win32.formatNumber(self, value, groupping)
    end
    return win32.formatNumber(value, groupping, precision)
end

function Win32.getCurrentTimeZone(self)
    return win32.getCurrentTimeZone()
end

function Win32.getRegistry(self, keyName, valueName)
    if (Win32.__index ~= self) then
        return win32.getRegistry(self, keyName)
    end
    return win32.getRegistry(keyName, valueName)
end

function Win32.getTimeZone(self, name)
    if (Win32.__index ~= self) then
        return win32.getTimeZone(self)
    end
    return win32.getTimeZone(name)
end

function Win32.getTimeZonesList(self)
    local result = {}
    local tmpresult = win32.getTimeZonesList()

    for i = 1, #tmpresult, 1 do  
        result[i - 1] = tmpresult[i];
    end
    return result
end

function Win32.hfTickCount(self)
    return win32.hfTickCount()
end

function Win32.isAttribute(self, attributes, attribute)
    if (Win32.__index ~= self) then
        return win32.isAttribute(self, attributes)
    end
    return win32.isAttribute(attributes, attribute)
end

function Win32.moveFile(self, existingFileName, newFileName)
    if (Win32.__index ~= self) then
        return win32.moveFile(self, existingFileName)
    end
    return win32.moveFile(existingFileName, newFileName)
end

function Win32.setRegistry(self, keyName, valueName, value)
    if (Win32.__index ~= self) then
        return win32.setRegistry(self, keyName, valueName)
    end
    return win32.setRegistry(keyName, valueName, value)
end

function Win32.splitFileName(self, fileName)
    local result = {}
    local tmpresult = {}
    if (Win32.__index ~= self) then
        tmpresult = {win32.splitFileName(self)};
    else
        tmpresult = {win32.splitFileName(fileName)};
    end
    local i,v
    for i,v in ipairs(tmpresult) do
        result[i - 1] = v
    end
    return result
end

function Win32.tempFileName(self)
    return win32.tempFileName()
end

function Win32.tempFolder(self)
    return win32.tempFolder()
end

function Win32.tickCount(self)
    return win32.tickCount()
end

-- coroutine
Coroutine = {}
Coroutine.__index = Coroutine
function Coroutine.create(self, f)
    if (Coroutine.__index ~= self) then
        return coroutine.create(self)
    end
    return coroutine.create(fileName)
end

function Coroutine.resume(self, ...)
    local unpack = table.unpack or unpack
    if (Coroutine.__index ~= self) then
      return coroutine.resume(self, unpack({...}))
    end
    return coroutine.resume(unpack({...}))
end

function Coroutine.running(self)
  return coroutine.running();
end

function Coroutine.status(self, co)
  if (Coroutine.__index ~= self) then
        return coroutine.create(self)
    end
    return coroutine.create(co)
end

function Coroutine.wrap(self, f)
  if (Coroutine.__index ~= self) then
        return coroutine.create(self)
    end
    return coroutine.create(f)
end

function Coroutine.yield(self, ...)
    local unpack = table.unpack or unpack
    if (Coroutine.__index ~= self) then
      return coroutine.yield(self, unpack({...}))
    end
    return coroutine.yield(unpack({...}))
end

-- package
Package = {}
Package.__index = Package
Package.cpath = package.cpath
Package.loaded = package.loaded
Package.loaders = package.loaders
Package.path = package.path
Package.preload = package.preload

function Package.loadlib(self, libname, funcname)
    if (Package.__index ~= self) then
        return package.loadlib(self, libname)
    end
    return package.loadlib(libname, funcname)
end

function Package.seeall(self, module)
    if (Package.__index ~= self) then
        return package.seeall(self)
    end
    return package.seeall(module)
end

-- io
IO = {}
IO.__index = IO

function IO.close(self, file)
    if (IO.__index ~= self) then
        return io.close(self)
    end
    return io.close(file)
end

function IO.flush(self)
    return io.flush();
end

function IO.input(self, file)
    if (IO.__index ~= self) then
        return io.input(self)
    end
    return io.input(file)
end

function IO.lines(self, filename)
    if (IO.__index ~= self) then
        return io.lines(self)
    end
    return io.lines(filename)
end

function IO.open(self, filename, mode)
    if (IO.__index ~= self) then
        return io.open(self, filename)
    end
    return io.open(filename, mode)
end

function IO.output(self, file)
    if (IO.__index ~= self) then
        return io.output(self)
    end
    return io.output(file)
end

function IO.popen(self, prog, mode)
    if (IO.__index ~= self) then
        return io.popen(self, prog)
    end
    return io.popen(prog, mode)
end

function IO.read(self, ...)
  local unpack = table.unpack or unpack
  if (IO.__index ~= self) then
    return io.read(self, unpack({...}))
  end
  return io.read(unpack({...}))
end

function IO.tmpfile(self)
    return io.tmpfile();
end

function IO.type(self, obj)
    if (IO.__index ~= self) then
        return io.type(self)
    end
    return io.type(obj)
end

function IO.write(self, ...)
  local unpack = table.unpack or unpack
  if (IO.__index ~= self) then
    return io.write(self, unpack({...}))
  end
  return io.write(unpack({...}))
end

-- debug
Debug = {}
Debug.__index = Debug

function Debug.debug()
    return debug.debug();
end

function Debug.getfenv(self, o)
    if (Debug.__index ~= self) then
        return debug.getfenv(self)
    end
    return debug.getfenv(o);
end

function Debug.gethook(self, thread)
    if (Debug.__index ~= self) then
        return debug.gethook(self)
    end
    return debug.gethook(thread);
end

function Debug.getinfo(self, thread, func, what)
    if (Debug.__index ~= self) then
        return debug.getinfo(self, thread, func)
    end
    return debug.getinfo(thread, func, what);
end

function Debug.getlocal(self, thread, level, loc)
    if (Debug.__index ~= self) then
        return debug.getlocal(self, thread, level)
    end
    return debug.getlocal(thread, level, loc);
end

function Debug.getmetatable(self, object)
    if (Debug.__index ~= self) then
        return debug.getmetatable(self)
    end
    return debug.getmetatable(object);
end

function Debug.getregistry()
    return debug.getregistry();
end

function Debug.getupvalue(self, func, up)
    if (Debug.__index ~= self) then
        return debug.getupvalue(self, func)
    end
    return debug.getupvalue(func, up);
end

function Debug.setfenv(self, object, table)
    if (Debug.__index ~= self) then
        return debug.setfenv(self, object)
    end
    return debug.setfenv(object, table);
end

function Debug.sethook(self, thread, hook, mask, count)
    if (Debug.__index ~= self) then
        return debug.sethook(self, thread, hook, mask)
    end
    return debug.sethook(thread, hook, mask, count);
end

function Debug.setlocal(self, thread, level, loc, value)
    if (Debug.__index ~= self) then
        return debug.setlocal(self, thread, level, loc)
    end
    return debug.setlocal(thread, level, loc, value);
end

function Debug.setmetatable(self, object, table)
    if (Debug.__index ~= self) then
        return debug.setmetatable(self, object)
    end
    return debug.setmetatable(object, table);
end

function Debug.setupvalue(self, func, up, value)
    if (Debug.__index ~= self) then
        return debug.setupvalue(self, func, up)
    end
    return debug.setupvalue(func, up, value);
end

function Debug.traceback(self, thread, message)
    if (Debug.__index ~= self) then
        return debug.traceback(self, thread)
    end
    return debug.traceback(thread, message);
end


GS_LOOP_TABLE_CONTINUE = {}
GS_LOOP_TABLE_CONTINUE.__index = GS_LOOP_TABLE_CONTINUE

GS_LOOP_TABLE_BREAK = {}
GS_LOOP_TABLE_BREAK.__index = GS_LOOP_TABLE_BREAK
--other functions

function InitMigration()

    core.RealAppPath = core.app_path   

    function core.app_path(self)
       return core.RealAppPath();
    end
    
    core.RealAutoBuffer  = core.autoBuffer  

    function core.autoBuffer(self, stream, first, extent, updateFunction, buffersCount)
      if (core == self) then
        return core.RealAutoBuffer(stream, first, extent, updateFunction, buffersCount);
      end
      return core.RealAutoBuffer(self, stream, first, extent, updateFunction);
    end
    
    core.RealColors = core.colors   

    function core.colors(self)
       return core.RealColors();
    end
    
    core.RealCrosses  = core.crosses  

    function core.crosses(self, stream1, stream2, period1, period2)
      if (core == self) then
        return core.RealCrosses(stream1, stream2, period1, period2);
      end
      return core.RealCrosses(self, stream1, stream2, period1);
    end
    
    core.RealCrossesOver = core.crossesOver 

    function core.crossesOver(self, stream1, stream2, period1, period2)
      if (core == self) then
        return core.RealCrossesOver(stream1, stream2, period1, period2);
      end
      return core.RealCrossesOver(self, stream1, stream2, period1);
    end

    core.RealCrossesOverOrTouch = core.crossesOverOrTouch 

    function core.crossesOverOrTouch(self, stream1, level, period1, period2)
      if (core == self) then
        return core.RealCrossesOverOrTouch(stream1, level, period1, period2);
      end
      return core.RealCrossesOverOrTouch(self, stream1, level, period1);
    end
    
    core.RealCrossesUnder = core.crossesUnder

    function core.crossesUnder(self, stream1, stream2, period1, period2)
      if (core == self) then
        return core.RealCrossesUnder(stream1, stream2, period1, period2);
      end
      return core.RealCrossesUnder(self, stream1, stream2, period1);
    end

    core.RealCrossesUnderOrTouch = core.crossesUnderOrTouch

    function core.crossesUnderOrTouch(self, stream1, level, period1, period2)
      if (core == self) then
        return core.RealCrossesUnderOrTouch(stream1, level, period1, period2);
      end
      return core.RealCrossesUnderOrTouch(self, stream1, level, period1);
    end
    
    core.RealDate = core.date

    function core.date(self, year, month, day)
      if (core == self) then
        return core.RealDate(year, month, day);
      end
      return core.RealDate(self, year, month);
    end
    
    core.RealDatetime = core.datetime

    function core.datetime(self, year, month, day, hour, minute, second)
      if (core == self) then
        return core.RealDatetime(year, month, day, hour, minute, second);
      end
      return core.RealDatetime(self, year, month, day, hour, minute);
    end
    
    core.RealDateToTable = core.dateToTable

    function core.dateToTable(self, date)
      if (core == self) then
        return core.RealDateToTable(date);
      end
      return core.RealDateToTable(self);
    end
    
    core.RealDrawLine = core.drawLine

    function core.drawLine(self, output, range, value1, position1, value2, position2)
      if (core == self) then
        return core.RealDrawLine(output, range, value1, position1, value2, position2);
      end
      return core.RealDrawLine(self, output, range, value1, position1, value2);
    end
    
    core.RealFindDate = core.findDate 

    function core.findDate(self, stream, date, precise)
      if (core == self) then
        return core.RealFindDate(stream, date, precise);
      end
      return core.RealFindDate(self, stream, date);
    end
    
    core.RealFormatDate = core.formatDate 

    function core.formatDate(self, date)
      if (core == self) then
        return core.RealFormatDate(date);
      end
      return core.RealFormatDate(self);
    end
    
    core.RealGetcandle = core.getcandle

    function core.getcandle(self, barSize, datetime, tradingDayOffset, tradingWeekOffset)
      local result = {}
      local tmpresult = {}
      if (core == self) then
        tmpresult = {core.RealGetcandle(barSize, datetime, tradingDayOffset, tradingWeekOffset)};
      else
        tmpresult = {core.RealGetcandle(seld, barSize, datetime, tradingDayOffset)};
      end
      local i,v
      for i,v in ipairs(tmpresult) do
        result[i - 1] = v
      end
      return result
    end
    
    core.RealIsnontrading = core.isnontrading

    function core.isnontrading(self, datetime, tradingDayOffset)
      local result = {}
      local tmpresult = {}
      if (core == self) then
        tmpresult = {core.RealIsnontrading(datetime, tradingDayOffset)};
      else
        tmpresult = {core.RealIsnontrading(seld, datetime)};
      end
      local i,v
      for i,v in ipairs(tmpresult) do
        result[i - 1] = v
      end
      return result
    end
    
    core.RealMakeHttpLoader = core.makeHttpLoader

    function core.makeHttpLoader(self)
       return core.RealMakeHttpLoader();
    end

    core.RealMakeArray = core.makeArray

    function core.makeArray(self, size)
      if (core == self) then
        return core.RealMakeArray(size);
      end
      return {core.RealMakeArray(self)};
    end
    
    core.RealNow = core.now

    function core.now(self)
      return core.RealNow();
    end
    
    core.RealParseCsv = core.parseCsv

    function core.parseCsv(self, string, separator)
      if (core == self) then
        return core.RealParseCsv(string, separator);
      end
      return core.RealParseCsv(self, string);
    end
    
    core.RealRange = core.range

    function core.range(self, from, to)
      if (core == self) then
        return core.RealRange(from, to);
      end
      return core.RealRange(self, from);
    end
    
    core.RealRangeFrom = core.rangeFrom

    function core.rangeFrom(self, from, length)
      if (core == self) then
        return core.RealRangeFrom(from, length);
      end
      return core.RealRangeFrom(self, from);
    end
    
    core.RealRangeFrom1 = core.rangeFrom1

    function core.rangeFrom1(self, from, number)
      if (core == self) then
        return core.RealRangeFrom1(from, number);
      end
      return core.RealRangeFrom1(self, from);
    end

    core.RealRangeTo = core.rangeTo

    function core.rangeTo(self, to, length)
      if (core == self) then
        return core.RealRangeTo(to, length);
      end
      return core.RealRangeTo(self, from);
    end

    core.RealRangeTo1 = core.rangeTo1

    function core.rangeTo1(self, to, number)
      if (core == self) then
        return core.RealRangeTo1(to, number);
      end
      return core.RealRangeTo1(self, from);
    end

    core.RealRequires = core.requires

    function core.requires(self, major, minor, exact)
      if (core == self) then
        return core.RealRequires(major, minor, exact);
      end
      return core.RealRequires(self, major, minor);
    end
    
    core.RealRGB = core.rgb

    function core.rgb(self, r, g, b)
      if (core == self) then
        return core.RealRGB(r, g, b);
      end
      return core.RealRGB(self, r, g);
    end

    core.RealEraseStream = core.eraseStream

    function core.eraseStream(self, stream, from, to)
      if (core == self) then
        return core.RealEraseStream(stream, from, to);
      end
      return core.RealEraseStream(self, stream, from);
    end
    
    core.RealTableToDate = core.tableToDate

    function core.tableToDate(self, date)
      if (core == self) then
        return core.RealTableToDate(date);
      end
      return core.RealTableToDate(self);
    end
    
    core.RealValuemap = core.valuemap 

    function core.valuemap(self)
       return core.RealValuemap();
    end

    core.RealVersion = core.version

    function core.version(self)
      local result = {}
      local tmpresult = {core.RealVersion()}
      local i,v
      for i,v in ipairs(tmpresult) do
        result[i - 1] = v
      end
      return result
    end

    core.RealTouches = core.touches

    function core.touches(self, stream1, stream2, period1, period2)
      if (core == self) then
        return core.RealTouches(stream1, stream2, period1, period2);
      end
      return core.RealTouches(self, stream1, stream2, period1);
    end

    RealType = type
    function type(v)
        result = RealType(v)
        if (result == "nil") then
            return nil
        end
        return result
    end
end

function BinaryOperationAddition(a, b)
  function testArg(arg)
    return (arg * 1)
  end

  local res
  if pcall(testArg, a) and pcall(testArg, b) then
    return (a * 1) + (b * 1) end
  if a == nil then
    if pcall(testArg, b) then
        a = 0
    else
        a = ""
    end
  end
  if b == nil then
    if pcall(testArg, a) then
        b = 0
    else
        b = ""
    end
  end
  return tostring(a) .. tostring(b)
end

function BinaryOperationSubtraction(a, b)
  function testArg(arg)
    return (arg * 1)
  end

  local res
  if pcall(testArg, a) and pcall(testArg, b) then
    return (a * 1) - (b * 1) end
  if a == nil then
    if pcall(testArg, b) then
        a = 0
    else
        a = ""
    end
  end
  if b == nil then
    if pcall(testArg, a) then
        b = 0
    else
        b = ""
    end
  end
  return NaN
end


function BinaryOperationMultiplication(a, b)
  function testArg(arg)
    return (arg * 1)
  end

  local res
  if pcall(testArg, a) and pcall(testArg, b) then
    return (a * 1) * (b * 1) end
  if a == nil then
    if pcall(testArg, b) then
        a = 0
    else
        a = ""
    end
  end
  if b == nil then
    if pcall(testArg, a) then
        b = 0
    else
        b = ""
    end
  end
  return NaN
end


function BinaryOperationDivision(a, b)
  function testArg(arg)
    return (arg * 1)
  end

  local res
  if pcall(testArg, a) and pcall(testArg, b) then
    return (a * 1) / (b * 1) end
  if a == nil then
    if pcall(testArg, b) then
        a = 0
    else
        a = ""
    end
  end
  if b == nil then
    if pcall(testArg, a) then
        b = 0
    else
        b = ""
    end
  end
  return NaN
end


function BinaryOperationModulus(a, b)
  function testArg(arg)
    return (arg * 1)
  end

  local res
  if pcall(testArg, a) and pcall(testArg, b) then
    return (a * 1) % (b * 1) end
  if a == nil then
    if pcall(testArg, b) then
        a = 0
    else
        a = ""
    end
  end
  if b == nil then
    if pcall(testArg, a) then
        b = 0
    else
        b = ""
    end
  end
  return NaN
end

function BinaryOperationEqual(a, b)
  function testArg(arg)
    return (arg * 1)
  end

  if a == nil and b == nil then
    return true
  elseif a == nil or b == nil then
    return false
  end

  tmpA = tonumber(a)
  tmpB = tonumber(b)
  if tmpA ~= nil and tmpB ~= nil then
    return tmpA == tmpB end
  return a == b
end

function BinaryOperationEqualValueType(a, b)
  if (type(a) == type(b)) then
    return BinaryOperationEqual(a, b) end
  return false
end

function BinaryOperationNotEqual(a, b)
  return not BinaryOperationEqual(a, b)
end

function BinaryOperationNotEqualValueType(a, b)
  if (type(a) == type(b)) then
    return BinaryOperationNotEqual(a, b) end
  return true
end

function BinaryOperationLessThan(a, b)
  function testArg(arg)
    return (arg * 1)
  end

  local res
  if pcall(testArg, a) and pcall(testArg, b) then
    return (a * 1) < (b * 1) end
  if a == nil then
    if pcall(testArg, b) then
        a = 0
    else
        a = ""
    end
  end
  if b == nil then
    if pcall(testArg, a) then
        b = 0
    else
        b = ""
    end
  end
  return a < b
end

function BinaryOperationLessEqualThan(a, b)
  function testArg(arg)
    return (arg * 1)
  end

  local res
  if pcall(testArg, a) and pcall(testArg, b) then
    return (a * 1) <= (b * 1) end
  if a == nil then
    if pcall(testArg, b) then
        a = 0
    else
        a = ""
    end
  end
  if b == nil then
    if pcall(testArg, a) then
        b = 0
    else
        b = ""
    end
  end
  return a <= b
end

function BinaryOperationGreaterThan(a, b)
  function testArg(arg)
    return (arg * 1)
  end

  local res
  if pcall(testArg, a) and pcall(testArg, b) then
    return (a * 1) > (b * 1) end
  if a == nil then
    if pcall(testArg, b) then
        a = 0
    else
        a = ""
    end
  end
  if b == nil then
    if pcall(testArg, a) then
        b = 0
    else
        b = ""
    end
  end
  return a > b
end

function BinaryOperationGreaterEqualThan(a, b)
  function testArg(arg)
    return (arg * 1)
  end

  local res
  if pcall(testArg, a) and pcall(testArg, b) then
    return (a * 1) >= (b * 1) end
  if a == nil then
    if pcall(testArg, b) then
        a = 0
    else
        a = ""
    end
  end
  if b == nil then
    if pcall(testArg, a) then
        b = 0
    else
        b = ""
    end
  end
  return a >= b
end

function BinaryOperationAnd(a, b)
  if (type(a) == "boolean" and type(b) == "boolean") then
    return a and b end
    return b
end

function BinaryOperationOr(a, b)
  if (type(a) == "boolean" and type(b) == "boolean") then
    return a or b end
    return a
end

function UnaryOperationPlus(a)
    return a
end

function UnaryOperationMinus(a)
    return 0 - a
end

function Draw(stage, context)
  local realCreatePoints = context.createPoints;
  function context.createPoints(self)
    return wrap_ownerdrawnpoints(realCreatePoints(self))
  end

  local realMeasureText = context.measureText;
  function context.measureText(self, font, text, style)
    local result = {}
    local tmpresult = {realMeasureText(self, font, text, style)}
    local i,v
    for i,v in ipairs(tmpresult) do
      result[i - 1] = v
    end
    return result
  end

  local realPointOfPrice = context.pointOfPrice;
  function context.pointOfPrice(self, font, text, style)
    local result = {}
    local tmpresult = {realPointOfPrice(self, font, text, style)}
    local i,v
    for i,v in ipairs(tmpresult) do
      result[i - 1] = v
    end
    return result
  end

  local realPositionOfBar = context.positionOfBar;
  function context.positionOfBar(self, font, text, style)
    local result = {}
    local tmpresult = {realPositionOfBar(self, font, text, style)}
    local i,v
    for i,v in ipairs(tmpresult) do
      result[i - 1] = v
    end
    return result
  end

  return GS_HELPER_Draw(stage, context)
end

local terminal_execute = function (self, cookie, valuemap)
    local result = {}
    local res, mes = terminal:RealExecute(cookie, valuemap)
    result[0] = res
    result[1] = mes
    return result
end
   
function UpdateWrapper()
    if (terminal == nil) then
        return
    end
    if (terminal.execute ~= terminal_execute) then
        terminal.RealExecute = terminal.execute
        terminal.execute = terminal_execute
    end
end

function Prepare(nameOnly)
    UpdateWrapper()
    return GS_HELPER_Prepare(nameOnly)
end
 
function Update(period, mode)
    UpdateWrapper()
    return GS_HELPER_Update(period, mode)
end

function ExtUpdate(id, source, period)
    UpdateWrapper()
    return GS_HELPER_ExtUpdate(id, source, period)
end

function GS_CALL_HELPER(x)
    return x()
end

function GS_CREATE_REGULAR_EXPRESSION(str, flags)
  return regex.new(str, flags);
end