local function getLogPath()local path, fileName, fileHandle, cmd;path=os.getenv("USERPROFILE");if path~=nil then if string.find(path, "Users")~=
nil then path = path .. "\\Documents\\Marketscope";else path = path .. "\\Marketscope";end fileName=string.format("%s\\install.txt", path);
fileHandle=io.open(fileName, "w");if fileHandle==nil then cmd=string.format("MKDIR %s", path);os.execute(cmd);fileHandle = io.open(fileName, "w");
end if fileHandle~=nil then fileHandle:close();end end return path;end Logger={["OFF"]=0,["ERROR"]=1,["INFO"]=2,["DEBUG"]=3};Logger.__index
=Logger;function Logger:create(fileName,logLevel)assert(fileName~=nil,"Invalid log file name");assert(logLevel~=nil,"Invalid log level");assert(type(logLevel)
=="number","Invalid log level");assert(logLevel==Logger.OFF or logLevel==Logger.INFO or logLevel==Logger.DEBUG or logLevel==Logger.ERROR,
"Invalid log level");local logger={_logPath=getLogPath().."\\"..fileName..".txt",_logLevel=logLevel};setmetatable(logger,self);return logger;end function 
Logger:getLogPath()return self._logPath;end function Logger:writeLog(level,msg)local file=io.open(self._logPath,"a+");if file~=nil then file:write(os.date()
.."|"..level.."|"..msg.."\n");file:close();end end function Logger:info(msg)if self._logLevel>=Logger.INFO then self:writeLog("INFO",msg);end end 
function Logger:error(msg)if self._logLevel>=Logger.ERROR then self:writeLog("ERROR", msg);end end function Logger:debug(msg)if self._logLevel
>=Logger.DEBUG then self:writeLog("DEBUG", msg);end end

function Init()
	strategy:name(resources:get("name"));	
	
	strategy.parameters:addGroup(resources:get("param_group_title_mode"));
	strategy.parameters:addString("Mode", resources:get("param_mode_name"), resources:get("param_mode_description"), "Market");
	strategy.parameters:addStringAlternative("Mode", resources:get("param_mode_market"), "", "Market");
	strategy.parameters:addStringAlternative("Mode", resources:get("param_mode_entry"), "", "Entry");
	strategy.parameters:addString("TID", resources:get("param_ticket"), resources:get("param_ticket_description"), "");
	strategy.parameters:setFlag("TID", core.FLAG_TRADE);
	strategy.parameters:addString("OID", resources:get("param_order"), resources:get("param_order_description"), "");
	strategy.parameters:setFlag("OID", core.FLAG_ORDER);
	
	strategy.parameters:addGroup(resources:get("param_group_title_profit"))
	strategy.parameters:addDouble("TP", resources:get("param_target_profit"), resources:get("param_target_profit_description"), 20, -10000, 10000);
	strategy.parameters:addDouble("OS", resources:get("param_offset"), resources:get("param_offset_description"), -2, -10000, 10000);
	strategy.parameters:addInteger("TRLP", resources:get("param_trail_pips"), resources:get("param_trail_pips_description"), 10, 0, 100000);
	
	strategy.parameters:addGroup(resources:get("param_group_title_other"));
	strategy.parameters:addBoolean("DB", resources:get("param_debug"), "", true);
end

local logger;
local targetProfit;
local offset;
local debug;
local trailPips;
local tradeID;
local orderID;
local mode;
local run = true;

function Prepare(nameOnly)
	mode = instance.parameters.Mode;
	tradeID  = instance.parameters.TID;
	targetProfit  = instance.parameters.TP;
	offset = instance.parameters.OS * instance.bid:pipSize();
	debug = instance.parameters.DB;
	trailPips = instance.parameters.TRLP;
	orderID = instance.parameters.OID;
	
	local name;
	if mode == "Market" then
		name = resources:get("name") .. " (" .. resources:get("param_mode_name") .. ": " .. mode .. ", " .. resources:get("param_ticket")  .. ": " .. tradeID 
			.. ", " .. resources:get("param_target_profit") .. ": " .. targetProfit .. ", " .. resources:get("param_offset") .. ": "  .. offset .. ", " .. resources:get("param_trail_pips") .. ": " .. trailPips .. ")";
		if debug then
			logger = Logger:create("breakeven_market_" .. tradeID, Logger.DEBUG);
		else 
			logger = Logger:create("breakeven_market_" .. tradeID, Logger.INFO);
		end
	else 
		-- Reset the value of our tradeID variable to the target TradeID of their order. The user input at this point is invalid.
		tradeID = core.host:findTable("orders"):find("OrderID", orderID).TradeID;
		name = resources:get("name") .. " (" .. resources:get("param_mode_name") .. ": " .. mode .. ", " .. resources:get("param_order")  .. ": " .. orderID
			.. ", " .. resources:get("param_target_profit") .. ": " .. targetProfit .. ", " .. resources:get("param_offset") .. ": "  .. offset .. ", " .. resources:get("param_trail_pips") .. ": " .. trailPips .. ")";
		if debug then
			logger = Logger:create("breakeven_entry_" .. tradeID, Logger.DEBUG);
		else 
			logger = Logger:create("breakeven_entry_" .. tradeID, Logger.INFO);
		end
	end
	instance:name(name);
	logger:info("Breakeven initialized: " .. name)
end

function EditOrder(rate, tradeID, openOrderID)
	logger:debug("Preparing to edit order for TradeID: " .. tradeID .. " and OpenOrderID " .. openOrderID);
	local enum, row, order;
	enum = core.host:findTable("orders"):enumerator();
	row = enum:next();
	while row ~= nil do
		logger:debug("Order found. Type: " .. row.Type .. ", TradeID: " .. row.TradeID .. ", ContingencyID: " .. row.ContingencyID);
		-- Orders of type 'S' with our target TradeID should be edited. This is the UK scenario
		-- Orders of type 'SE' with our target OpenOrderID should be edited. This is the US scenario
		
		-- Note that we are casting 'openOrderID' from string to number because the ContingencyID field of the order table is apparently a number,
		-- though per the docs we expect a string. This ensures the comparison does not fail because of the type difference. We will cast the 
		-- ContingencyID field here to number just in case this is changed.
		if (row.Type == "SE" and tonumber(row.ContingencyID) == tonumber(openOrderID)) or (row.Type == "S" and row.TradeID == tradeID) then
			logger:info("Modifying stop. OrderID: " .. row.OrderID .. ", Current rate: " .. row.Rate .. ", Next rate: " .. rate .. ", Trail pips: " .. trailPips .. ", Bid: " .. instance.bid[NOW] .. ", Ask: " .. instance.ask[NOW]);
		
			local valuemap = core.valuemap();
			valuemap.Command  = "EditOrder";
			valuemap.OrderID  = row.OrderID;
			valuemap.AcctID = row.AccountID;
			valuemap.Rate = rate;
			valuemap.TrailUpdatePips = trailPips;
	
			local success, msg = terminal:execute(500, valuemap);

			if not(success) then
				logger:error("EditOrder request failed to send due to: " .. msg);
			end		
		
		end
		row = enum:next();
	end
end

function Update()
	if run then
		local row = core.host:findTable("trades"):find("TradeID", tradeID);
		if row ~= nil then
			if row.PL >= targetProfit then
				logger:info("Target profit level reached! Target profit: " .. targetProfit .. ", Current P/L: " .. row.PL);
				
				-- Iterate through the entire trades table and
				-- make sure all trades opened with this OpenOrderID are
				-- update (in the event a partial fill occurred)
				logger:debug("Finding all open trades that share the corresponding OpenOrderID " .. row.OpenOrderID);
				local enum, tradeRow;
				enum = core.host:findTable("trades"):enumerator();
				tradeRow = enum:next();
				while tradeRow ~= nil do
					logger:debug("Trade found. TradeID: "  .. tradeRow.TradeID .. ", OpenOrderID: " .. tradeRow.OpenOrderID);
					if tradeRow.OpenOrderID == row.OpenOrderID then
						logger:debug("Found matching trade. Updating stop for TradeID " .. tradeRow.TradeID);
						if tradeRow.BS == "B" then
							EditOrder(tradeRow.Open + offset, tradeRow.TradeID, tradeRow.OpenOrderID);
						else
							EditOrder(tradeRow.Open - offset, tradeRow.TradeID, tradeRow.OpenOrderID);
						end
					end
					tradeRow = enum:next();
				end
				run = false;
				-- Strategy completed. Stop the strategy. 
				core.host:execute("stop");
			end
		end
	end
	
end

function AsyncOperationFinished(cookie, success, message) end

